$(document).ready(function () {
  fold();
  $("form").submit(handleForm);
  $("#reset").click(reset);
})

function handleForm(e) {
  // extract computable values
  const q1v = $("#q1").val();
  const q2v = $("#q2").val();
  const q3o1v = $("#q3o1").prop("checked");
  const q3o2v = $("#q3o2").prop("checked");
  const q3o3v = $("#q3o3").prop("checked");
  const q4o1v = $("#q4o1").prop("checked");
  const q4o2v = $("#q4o2").prop("checked");
  const q5v = $("#q5").val();

  // compute success
  const mark1 = markQuestion1(q1v);
  const mark2 = markQuestion2(q2v);
  const mark3 = markQuestion3(q3o1v, q3o2v, q3o3v);
  const mark4 = markQuestion4(q4o1v, q4o2v);
  const mark5 = markQuestion5(q5v);
  const total = mark1 + mark2 + mark3 + mark4 + mark5
  const successRatio = (total / 5) * 100;

  // fill result
  fillResult(total, successRatio);

  // show result
  showResult(e);
}

function markQuestion1(v) {
  if (v.trim() === "") {
    return 0;
  } else {
    return 1;
  }
}

function markQuestion2(v) {
  if (v.toLowerCase() === "si") {
    return 1;
  } else {
    return 0;
  }
}

function markQuestion3(v1, v2, v3) {
  if (v1 && !v2 && v3) {
    return 1;
  } else {
    return 0;
  }
}

function markQuestion4(v1, v2) {
  if (v1) {
    return 1;
  } else {
    return 0;
  }
}

function markQuestion5(v) {
  if (v === "q5o2") {
    return 1;
  } else {
    return 0;
  }
}

function fillResult(hits, score) {
  $("#hits").text(hits);
  $("#score").text(score + "%");
}

function showResult(e) {
  e.preventDefault();
  $(".modal").dialog({
    modal: true,
  })
}

function reset() {
  // clean fields 
  $("#q1").val("");
  $("#q2").val("");
  $("#q3o1").prop("checked", false);
  $("#q3o2").prop("checked", false);
  $("#q3o3").prop("checked", false);
  $("#q4o1").prop("checked", false);
  $("#q4o2").prop("checked", false);
  $("#q5").val("");
}

function fold() {
  $("form").accordion({
    active: false,
    collapsible: true,
    header: ".question > :first-child",
    heightStyle: "content",
    icons: {
      "header": "ui-icon-plus",
      "activeHeader": "ui-icon-minus"
    }
  })
}

